package feature.produce.service;

import feature.produce.model.DTSConfig;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.tuple.Pair;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.Pipeline;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * https://help.aliyun.com/zh/maxcompute/user-guide/java-sdk-1/?spm=a2c4g.11174283.0.0.6d0111c1E15lI3
 *
 * @author dyp
 */
public class RedisService {
    private int port = 6379;
    private String password = "Wqsd@2019";
    private String hostName = "r-bp1wwqqkjqwwkxgbup.redis.rds.aliyuncs.com";

    private void mSetEx(Iterator<Pair<String, String>> keyValues, long expire, TimeUnit timeUnit) {
        Jedis jedis = new Jedis(hostName, port);
        jedis.auth(password);
        Pipeline pipeline = jedis.pipelined();
        while (keyValues.hasNext()) {
            Pair<String, String> p = keyValues.next();
            pipeline.setex(p.getLeft(), timeUnit.toSeconds(expire), p.getRight());
        }
        pipeline.sync();
        jedis.close();
    }

    public void mSet(Iterator<Pair<String, String>> keyValues, DTSConfig config) {
        long expire = config.getRedis().getExpire();
        mSetEx(keyValues, expire, TimeUnit.SECONDS);
    }

    public String redisKey(Map<String, String> fieldValueMap, DTSConfig config) {
        // Note：写入和读取的key生成规则应保持一致
        List<String> fields = config.getRedis().getKey();
        if (CollectionUtils.isEmpty(fields)) {
            return config.getRedis().getPrefix();
        }
        StringBuilder sb = new StringBuilder();
        if (StringUtils.isNotBlank(config.getRedis().getPrefix())) {
            sb.append(config.getRedis().getPrefix());
        }
        for (String field : fields) {
            sb.append(":");
            sb.append(fieldValueMap.get(field));
        }
        return sb.toString();
    }
}